
#include "inc.h"

#include "minix.h"
#include "iwram_arm.h"
#include "bios_arm.h"
#include "div_arm.h"
#include "gbfs.h"
#include "lib.h"

#include "sizuku.h"

//---------------------------------------------------------------------------
ST_SIZUKU Sizuku;


//---------------------------------------------------------------------------
EWRAM_CODE void SizukuInit()
{
	_Memset((u8*)&Sizuku, 0x00, sizeof(ST_SIZUKU));
}
//---------------------------------------------------------------------------
//ViItO̕ϊ
EWRAM_CODE u8 SizukuCalcSysFlag(u8 no)
{
	switch (no)
	{
	case 0:			//GfBOԋL^(񏉊Ώ)
		return 0;

	case 1:			//GtO
		return 1;

	case 0x40:		//ڗqƖ
	case 0x41:		//le
	case 0x42:		//ŕς
	case 0x43:		//̈قŁc
	case 0x44:		//ڗqu͂Ȃv
	case 0x45:		//ڗq TRUE  (񏉊Ώ)
	case 0x46:		//ڗq HAPPY (񏉊Ώ)
	case 0x47:		//D[gON
	case 0x48:		//D HV[
	case 0x49:		//炭gp
	case 0x4a:		//ړꏊp
	case 0x4b:		//IS[܂
		return 2 + no - 0x40;

	default:
		TRACEOUT("SizukuGetSysFlag Bad Flag No[%02x]", no);
		for(;;){}
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE u8 SizukuGetSysFlag(u8 no)
{
	return Sizuku.sysFlag[ SizukuCalcSysFlag(no) ];
}
//---------------------------------------------------------------------------
EWRAM_CODE void SizukuSetSysFlag(u8 no, u8 val)
{
	Sizuku.sysFlag[ SizukuCalcSysFlag(no) ] = val;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SizukuAddSysFlag(u8 no, u8 val)
{
	Sizuku.sysFlag[ SizukuCalcSysFlag(no) ] += val;
}
//---------------------------------------------------------------------------
//BGMp[^̕ϊ
EWRAM_CODE u8 SizukuGetBgmNo(u8 no)
{
	if(no == 14)
	{
		return 2;
	}
	else if(no < 16)
	{
		return no+2;
	}

	return no+1;
}
